searchNodes=[{"doc":"Implements an ETS based key/value storage with following additional features:row level synchronized writes (inserts, read/modify/write updates, deletes)TTL supportmodification callbacksExample usage:ConCache.start_link(name: :my_cache, ttl_check_interval: false) ConCache.put(:my_cache, :foo, 1) ConCache.get(:my_cache, :foo) # 1The following rules apply:Modifications are by isolated per row. Two processes can't modify the same row at the same time. Dirty operations are available through dirty_ equivalents.Reads are dirty by default. You can use isolated/4 to perform isolated custom operations.Operations are always performed in the caller process. Custom lock implementation is used to ensure synchronism. See README.md for more details.In this example, items don't expire. See start_link/1 for details on how to setup expiry.See start_link/1 for more details.","ref":"ConCache.html","title":"ConCache","type":"module"},{"doc":"Deletes the item from the cache.","ref":"ConCache.html#delete/2","title":"ConCache.delete/2","type":"function"},{"doc":"Dirty equivalent of delete/2.","ref":"ConCache.html#dirty_delete/2","title":"ConCache.dirty_delete/2","type":"function"},{"doc":"Dirty equivalent of fetch_or_store/3.","ref":"ConCache.html#dirty_fetch_or_store/3","title":"ConCache.dirty_fetch_or_store/3","type":"function"},{"doc":"Dirty equivalent of get_or_store/3.","ref":"ConCache.html#dirty_get_or_store/3","title":"ConCache.dirty_get_or_store/3","type":"function"},{"doc":"Dirty equivalent of insert_new/3.","ref":"ConCache.html#dirty_insert_new/3","title":"ConCache.dirty_insert_new/3","type":"function"},{"doc":"Dirty equivalent of put/3.","ref":"ConCache.html#dirty_put/3","title":"ConCache.dirty_put/3","type":"function"},{"doc":"Dirty equivalent of update/3.","ref":"ConCache.html#dirty_update/3","title":"ConCache.dirty_update/3","type":"function"},{"doc":"Dirty equivalent of update_existing/3.","ref":"ConCache.html#dirty_update_existing/3","title":"ConCache.dirty_update_existing/3","type":"function"},{"doc":"Returns the ets table managed by the cache.","ref":"ConCache.html#ets/1","title":"ConCache.ets/1","type":"function"},{"doc":"Retrieves the item from the cache, or inserts the new item.If the item exists in the cache, it is retrieved. Otherwise, the lambda function is executed and its result is stored under the given key, but only if it returns an {:ok, value} tuple. If the {:error, reason} tuple is returned, caching is not done and the error becomes the result of the function. If the lambda returns none of the above, a RuntimeError is raised.The lambda may return either a plain value or %ConCache.Item{}.This function is not supported by :bag and :duplicate_bag ETS tables.Note: if the item is already in the cache, this function amounts to a simple get without any locking, so you can expect it to be fairly fast.","ref":"ConCache.html#fetch_or_store/3","title":"ConCache.fetch_or_store/3","type":"function"},{"doc":"Reads the item from the cache.A read is always &quot;dirty&quot;, meaning it doesn't block while someone is updating the item under the same key. A read doesn't expire TTL of the item, unless touch_on_read option is set while starting the cache.","ref":"ConCache.html#get/2","title":"ConCache.get/2","type":"function"},{"doc":"Retrieves the item from the cache, or inserts the new item.If the item exists in the cache, it is retrieved. Otherwise, the lambda function is executed and its result is stored under the given key.The lambda may return either a plain value or %ConCache.Item{}.This function is not supported by :bag and :duplicate_bag ETS tables.Note: if the item is already in the cache, this function amounts to a simple get without any locking, so you can expect it to be fairly fast.","ref":"ConCache.html#get_or_store/3","title":"ConCache.get_or_store/3","type":"function"},{"doc":"Inserts the item into the cache unless it exists.","ref":"ConCache.html#insert_new/3","title":"ConCache.insert_new/3","type":"function"},{"doc":"Isolated execution over arbitrary lock in the cache.You can do whatever you want in the function, not necessarily related to the cache. The return value is the result of the provided lambda.This allows you to perform flexible isolation. If you use the key of your item as a key, then this operation will be exclusive to updates. This can be used e.g. to perform isolated reads:# Process A: ConCache.isolated(:my_cache, :my_item_key, fn() -&gt; ... end) # Process B: ConCache.update(:my_cache, :my_item, fn(old_value) -&gt; ... end)These two operations are mutually exclusive.","ref":"ConCache.html#isolated/4","title":"ConCache.isolated/4","type":"function"},{"doc":"Stores the item into the cache.","ref":"ConCache.html#put/3","title":"ConCache.put/3","type":"function"},{"doc":"Returns the number of items stored in the cache.","ref":"ConCache.html#size/1","title":"ConCache.size/1","type":"function"},{"doc":"Starts the server and creates an ETS table.Options:{:name, atom} - A name of the cache process.{:ttl_check_interval, time_ms | false} - Required. A check interval for TTL expiry. Provide a positive integer for expiry to work, or pass false to disable ttl checks. See below for more details on expiry.{:global_ttl, time_ms | :infinity} - The time after which an item expires. When an item expires, it is removed from the cache. Updating the item extends its expiry time.{:touch_on_read, true | false} - Controls whether read operation extends expiry of items. False by default.{:callback, callback_fun} - If provided, this function is invoked after an item is inserted or updated, or before it is deleted.{:acquire_lock_timeout, timeout_ms} - The time a client process waits for the lock. Default is 5000.{:ets_options, [ets_option] – The options for ETS process.In addition, following ETS options are supported::set - An ETS table will be of the :set type (default).:ordered_set - An ETS table will be of the :ordered_set type.:bag - An ETS table will be of the :bag type.:duplicate_bag - An ETS table will be of the :duplicate_bag type.:named_table:name:heir:write_concurrency:read_concurrencyChild specificationTo insert your cache into the supervision tree, pass the child specification in the shape of {ConCache, con_cache_options}. For example:{ConCache, [name: :my_cache, ttl_check_interval: false]}ExpiryTo configure expiry, you need to provide positive integer for the :ttl_check_interval option. This integer represents the millisecond interval in which the expiry is performed. You also need to provide the :global_ttl option, which represents the default TTL time for the item.TTL of each item is by default extended only on modifications. This can be changed with the touch_on_read: true option.If you need a granular control of expiry per each item, you can pass a ConCache.Item struct when storing data.If you don't want a modification of an item to extend its TTL, you can pass a ConCache.Item struct, with :ttl field set to :no_update.Choosing ttl_check_interval timeWhen expiry is configured, the owner process works in discrete steps, doing cleanups every ttl_check_interval milliseconds. This approach allows the owner process to do fairly small amount of work in each discrete step.Assuming there's no huge system overload, an item's max lifetime is thus global_ttl + ttl_check_interval [ms], after the last item's update.Thus, a lower value of ttl_check_interval time means more frequent purging which may reduce your memory consumption, but could also cause performance penalties. Higher values put less pressure on processing, but item expiry is less precise.","ref":"ConCache.html#start_link/1","title":"ConCache.start_link/1","type":"function"},{"doc":"Manually touches the item to prolongate its expiry.","ref":"ConCache.html#touch/2","title":"ConCache.touch/2","type":"function"},{"doc":"Similar to isolated/4 except it doesn't wait for the lock to be available.If the lock can be acquired immediately, it will be acquired and the function will be invoked. Otherwise, an error is returned immediately.","ref":"ConCache.html#try_isolated/4","title":"ConCache.try_isolated/4","type":"function"},{"doc":"Updates the item, or stores new item if it doesn't exist.The update_fun is invoked after the item is locked. Here, you can be certain that no other process will update this item, unless they are doing dirty updates or writing directly to the underlying ETS table. This function is not supported by :bag or :duplicate_bag ETS tables.The updater lambda must return one of the following:{:ok, value} - causes the value to be stored into the table{:error, reason} - the value won't be stored and {:error, reason} will be returned","ref":"ConCache.html#update/3","title":"ConCache.update/3","type":"function"},{"doc":"Updates the item only if it exists. Otherwise works just like update/3.","ref":"ConCache.html#update_existing/3","title":"ConCache.update_existing/3","type":"function"},{"doc":"","ref":"ConCache.html#t:callback_fun/0","title":"ConCache.callback_fun/0","type":"type"},{"doc":"","ref":"ConCache.html#t:ets_option/0","title":"ConCache.ets_option/0","type":"type"},{"doc":"","ref":"ConCache.html#t:fetch_or_store_fun/0","title":"ConCache.fetch_or_store_fun/0","type":"type"},{"doc":"","ref":"ConCache.html#t:key/0","title":"ConCache.key/0","type":"type"},{"doc":"","ref":"ConCache.html#t:options/0","title":"ConCache.options/0","type":"type"},{"doc":"","ref":"ConCache.html#t:store_fun/0","title":"ConCache.store_fun/0","type":"type"},{"doc":"","ref":"ConCache.html#t:store_value/0","title":"ConCache.store_value/0","type":"type"},{"doc":"","ref":"ConCache.html#t:t/0","title":"ConCache.t/0","type":"type"},{"doc":"","ref":"ConCache.html#t:update_fun/0","title":"ConCache.update_fun/0","type":"type"},{"doc":"","ref":"ConCache.html#t:value/0","title":"ConCache.value/0","type":"type"},{"doc":"This struct can be used in place of naked values to set per-item TTL values.","ref":"ConCache.Item.html","title":"ConCache.Item","type":"module"},{"doc":"","ref":"ConCache.Item.html#t:t/0","title":"ConCache.Item.t/0","type":"type"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"no new changes from 0.14.0","ref":"changelog.html#1-0","title":"Changelog - 1.0","type":"extras"},{"doc":"Requires Elixir 1.7 or newerAdded fetch_or_store/3 and dirty_fetch_or_store/3","ref":"changelog.html#0-14-0","title":"Changelog - 0.14.0","type":"extras"},{"doc":"removed a few compiler warnings","ref":"changelog.html#0-13-1","title":"Changelog - 0.13.1","type":"extras"},{"doc":"Breaking changesRequires Elixir 1.5 or newerThe ConCache.start_link function takes only one argument. Previously, you needed to pass two keyword lists, which have now been unified in a single kw list. See ConCache.start_link/1 for details.The ConCache.start_link parameters :ttl_check and :ttl are renamed to :ttl_check_interval and :global_ttl.The :ttl_check_interval parameter is now required. If you don't want expiry in your cache, you need to explicitly pass ttl_check_interval: false.If the :ttl_check_interval option is set to a positive integer, you also need to pass the :global_ttl option.If a cache is configured for expiry, but you want some item to not expire, you need to pass the atom :infinity as its TTL value (previously, it was 0).ImprovementsAdded child_spec/1. A ConCache child can now be specified as {ConCache, [name: :my_cache, ttl_check_interval: false]}.","ref":"changelog.html#0-13-0","title":"Changelog - 0.13.0","type":"extras"},{"doc":"Relaxed version requirement for ElixirProper early exit when the cache doesn't exist","ref":"changelog.html#0-12-1","title":"Changelog - 0.12.1","type":"extras"},{"doc":"Breaking changesElixir 1.4 is now required.The process started through ConCache.start_link is a supervisor (previously it was a worker). Make sure to adapt your supervisor specifications accordingly.ConCache.start has been removed.ImprovementsYou can now use bag, and duplicate_bag (thanks to fcevado for implementing it).Lock processes are now specific for each cache instance (previously they were shared between all of them). Multiple cache instances in the same system will not block each other.","ref":"changelog.html#0-12-0","title":"Changelog - 0.12.0","type":"extras"},{"doc":"Fix warnings on 1.3.0","ref":"changelog.html#0-11-1","title":"Changelog - 0.11.1","type":"extras"},{"doc":"ImprovementsSupport the avoiding prolongation of ttls when updated items through the :no_update ttl value in %ConCache.Item{}FixesNew items inserted with ConCache.update/3 and ConCache.dirty_update/3 never expired.","ref":"changelog.html#0-11-0","title":"Changelog - 0.11.0","type":"extras"},{"doc":"Improvementsadd ConCache.size/1","ref":"changelog.html#0-10-0","title":"Changelog - 0.10.0","type":"extras"},{"doc":"FixesSupport for Elixir 1.1","ref":"changelog.html#0-9-0","title":"Changelog - 0.9.0","type":"extras"},{"doc":"FixesProper unlocking of an item. Previously it was possible that a process keeps the resource locked forever if the lock attempt timed out.","ref":"changelog.html#0-8-1","title":"Changelog - 0.8.1","type":"extras"},{"doc":"Breaking changesRemoved following ConCache functions: size/1, memory/1, memory_bytes/1, get_all/1, with_existing/3Changed ConCache update functions: update/3, dirty_update/3, update_existing/3 and dirty_update_existing/3. The provided lambda now must return either {:ok, new_value} or {:error, reason}.Changed ConCache.try_isolated/4 - the function returns {:ok, result} or {:error, reason}Upgraded to the most recent ExActorFixesFixed possible race-conditions on client process crashFixed mutual exclusion of independent caches","ref":"changelog.html#0-8-0","title":"Changelog - 0.8.0","type":"extras"},{"doc":"Elixir v1.0.0","ref":"changelog.html#0-6-1","title":"Changelog - 0.6.1","type":"extras"},{"doc":"bugfix: balanced lock wasn't working properly","ref":"changelog.html#0-5-1","title":"Changelog - 0.5.1","type":"extras"},{"doc":"upgrade to Elixir v1.0.0-rc1","ref":"changelog.html#0-5-0","title":"Changelog - 0.5.0","type":"extras"},{"doc":"upgrade to Elixir v0.15.0","ref":"changelog.html#0-4-0","title":"Changelog - 0.4.0","type":"extras"},{"doc":"With this version, ConCache is turned into a proper application that obeys OTP principles. This required some changes to the way ConCache is used.First, ConCache is now an OTP application. Consequently, you should add it as an application dependency in your mix.exs: ... def application do [applications: [:con_cache, ...], ...] end ...This will make sure that before your app is started, ConCache required processes are started as well.To create a cache, you can use ConCache.start_link/0,1,2 or ConCache.start/0,1,2. These functions now return result in the form of {:ok, pid} where pid identifies the owner process of the underlying ETS table. You can use that pid as the first argument to exported functions from ConCache module.The first argument to both functions must contain ConCache options (unchanged), while the second argument contains GenServer start options. Both are by default empty lists.The cache owner process is not inserted into the supervision tree of the ConCache OTP application. It is your responsibility to place it in your own tree at the desired place.Of course, when using supervision, you can't use the ETS owner process pid to interface the cache, since this process can be restarted. Instead, you must rely on some registration facility. For example, this is how you can locally register the owner process, and use the alias to interface with the cache:# Specifying the alias of the ETS owner process iex(1)&gt; ConCache.start_link([], name: :my_cache) # Interfacing the cache via the registered alias iex(2)&gt; ConCache.put(:my_cache, :some_key, :some_value) iex(3)&gt; ConCache.get(:my_cache, :some_key) :some_valueWhen creating the cache from the supervision tree, use something like this in your specification:worker(ConCache, [con_cache_options, [name: ...]])And then interface the cache via the corresponding alias.Besides this simple local registration, you can also use {:global, some_alias}, and {:via, module, some_alias} format. For example, to register the process with gproc, you can do something like this:ConCache.start_link([], name: {:via, :gproc, :my_cache}) ... ConCache.put({:via, :gproc, :my_cache}, :some_key, :some_value)","ref":"changelog.html#0-3-0","title":"Changelog - 0.3.0","type":"extras"},{"doc":"ConCache ConCache (Concurrent Cache) is an ETS based key/value storage with following additional features:row level synchronized writes (inserts, read/modify/write updates, deletes)TTL supportmodification callbacks","ref":"readme.html","title":"ConCache","type":"extras"},{"doc":"Setup project and app dependency in your mix.exs: ... defp deps do [{:con_cache, &quot;~&gt; 0.13&quot;}, ...] end def application do [applications: [:con_cache, ...], ...] end ...A cache can be started using ConCache.start or ConCache.start_link functions. Both functions take two arguments - the first one being a list of ConCache options, and the second one a list of GenServer options for the process being started.Typically you want to start the cache from a supervisor:Supervisor.start_link( [ ... {ConCache, [name: :my_cache, ttl_check_interval: false]} ... ], ... )For OTP apps, you can generally find this in lib/&lt;myapp&gt;.ex. In the Phoenix web framework, look in the start function and add the worker to the children list.Notice the name: :my_cache option. The resulting process will be registered under this alias. Now you can use the cache as follows:# Note: all of these requests run in the caller process, without going through # the started process. ConCache.put(:my_cache, key, value) # inserts value or overwrites the old one ConCache.insert_new(:my_cache, key, value) # inserts value or returns {:error, :already_exists} ConCache.get(:my_cache, key) ConCache.delete(:my_cache, key) ConCache.size(:my_cache) ConCache.update(:my_cache, key, fn(old_value) -&gt; # This function is isolated on a row level. Modifications such as update, put, delete, # on this key will wait for this function to finish. # Modifications on other items are not affected. # Reads are always dirty. {:ok, new_value} end) # Similar to update, but executes provided function only if item exists. # Otherwise returns {:error, :not_existing} ConCache.update_existing(:my_cache, key, fn(old_value) -&gt; {:ok, new_value} end) # Returns existing value, or calls function and stores the result. # If many processes simultaneously invoke this function for the same key, the function will be # executed only once, with all others reading the value from cache. ConCache.get_or_store(:my_cache, key, fn() -&gt; initial_value end) # Similar to get_or_store/3 but works with :ok/:error tuples. # The value is cached only if the function returns an :ok tuple. ConCache.fetch_or_store(:my_cache, key, fn -&gt; case call_api() do # The processed value will be cached and returned as an :ok tuple. {:ok, data} -&gt; {:ok, process_data(data)} # The error tuple is propagated to the caller. {:error, _reason} = error -&gt; error end end)Dirty modifiers operate directly on ETS record without trying to acquire the row lock:ConCache.dirty_put(:my_cache, key, value) ConCache.dirty_insert_new(:my_cache, key, value) ConCache.dirty_delete(:my_cache, key) ConCache.dirty_update(:my_cache, key, fn(old_value) -&gt; ... end) ConCache.dirty_update_existing(:my_cache, key, fn(old_value) -&gt; ... end) ConCache.dirty_get_or_store(:my_cache, key, fn() -&gt; ... end) ConCache.dirty_fetch_or_store(:my_cache, key, fn() -&gt; ... end)CallbackYou can register your own function which will be invoked after an element is stored or deleted:{ConCache, [name: :my_cache, callback: fn(data) -&gt; ... end]} ConCache.put(:my_cache, key, value) # fun will be called with {:update, cache_pid, key, value} ConCache.delete(:my_cache, key) # fun will be called with {:delete, cache_pid, key}The delete callback is invoked before the item is deleted, so you still have the chance to fetch the value from the cache and do something with it.TTL{ConCache, [ name: :my_cache, ttl_check_interval: :timer.seconds(1), global_ttl: :timer.seconds(5) ]}This example sets up item expiry check every second, and sets the global expiry for all cache items to 5 seconds. Since ttl_check_interval is 1 second, the item lifetime might be at most 6 seconds.However, the item lifetime is renewed on every modification. Reads don't extend global_ttl, but this can be changed when starting cache:{ConCache, [ name: :my_cache, ttl_check_interval: :timer.seconds(1), global_ttl: :timer.seconds(5), touch_on_read: true ]}In addition, you can manually renew item's ttl:ConCache.touch(:my_cache, key)And you can override ttl for each item:ConCache.put(:my_cache, key, %ConCache.Item{value: value, ttl: ttl}) ConCache.update(:my_cache, key, fn(old_value) -&gt; {:ok, %ConCache.Item{value: new_value, ttl: ttl}} end)And you can update an item without resetting the item's ttl:ConCache.put(:my_cache, key, %ConCache.Item{value: value, ttl: :no_update}) ConCache.update(:my_cache, key, fn(old_value) -&gt; {:ok, %ConCache.Item{value: new_value, ttl: :no_update}} end)If you use ttl value of :infinity the item never expires.TTL check is not based on brute force table scan, and should work reasonably fast assuming the check interval is not too small. I broadly recommend ttl_check_interval to be at least 1 second, possibly more, depending on the cache size and desired ttl.If needed, you may also pass false to ttl_check_interval. This effectively stops con_cache from checking the ttl of your items:{ConCache, [ name: :my_cache, ttl_check_interval: false ]}","ref":"readme.html#usage-in-otp-applications","title":"ConCache - Usage in OTP applications","type":"extras"},{"doc":"A call to ConCache.start_link (or start) creates the so called cache owner process. This is the process that is the owner of the underlying ETS table and also the process where TTL checks are performed. No other operation (such as get or put) runs in this process.As you've seen from the examples above, it's your responsibility to place the cache owner process into your own supervision tree. This gives you the control of cache cleanup when some subtree terminates (since a termination of the owner process will release the ETS table).If for some reason :con_cache application is terminated, all cache owner processes will be terminated as well, regardless of the fact that they do not reside in the :con_cache supervision tree.Multiple cachesSometimes it can be useful to run multiple caches - say, if you need 2 caches with different global expiry values. Even though you can override ttl for each item individually, it might get tedious very quickly.By default it's not possible to run multiple caches under the same supervisor because child specification of each cache owner process has id equal to ConCache.However you can override default child specification and provide unique id:def start(_type, _args) do Supervisor.start_link( [ ... con_cache_child_spec(:my_cache_1, 100), con_cache_child_spec(:my_cache_2, 200) ... ], ... ) end defp con_cache_child_spec(name, global_ttl) do Supervisor.child_spec( { ConCache, [ name: name, ttl_check_interval: :timer.seconds(1), global_ttl: :timer.seconds(global_ttl) ] }, id: {ConCache, name} ) endSee Supervisor.child_spec/2 for details of this technique.","ref":"readme.html#supervision","title":"ConCache - Supervision","type":"extras"},{"doc":"Functions ConCache.start and ConCache.start_link return standard {:ok, pid} result. You can interface with the cache using this pid. As mentioned, cache operations are not running through this process - the pid is just used to discover the corresponding ETS table.Most of the time using pid to interface the cache is not appropriate. Just like in examples above, you usually want to give some alias to your cache, and then access it via this alias. In the examples above, we used name: :some_alias to provide local alias. Alternatively, you can use following formats for name option:{:global, some_alias} # globally registered alias {:via, module, some_alias} # registered through some module (e.g. gproc)In this case, you can just pass the same tuple to other ConCache functions. For example, to use the cache with gproc, you can do something like this:ConCache.start_link([], name: {:via, :gproc, :my_cache}) ... ConCache.put({:via, :gproc, :my_cache}, :some_key, :some_value)","ref":"readme.html#process-alias","title":"ConCache - Process alias","type":"extras"},{"doc":"Keep in mind that ConCache introduces a state to your system. Thus, when you're testing your application, some tests might accidentally compromise the execution of other tests. There are a couple of options to work around that:Use different keys in each test. This could help avoiding tests compromising each other.Before each test, force restart the ConCache process. This will ensure each test runs with the empty cache. setup do Supervisor.terminate_child(con_cache_supervisor, ConCache) Supervisor.restart_child(con_cache_supervisor, ConCache) :ok end Where con_cache_supervisor is the supervisor from which the ConCache process is started.Fetch all keys from the ets table, and delete each entry: setup do :my_cache |&gt; ConCache.ets |&gt; :ets.tab2list |&gt; Enum.each(fn({key, _}) -&gt; ConCache.delete(:my_cache, key) end) :ok end","ref":"readme.html#testing-in-your-application","title":"ConCache - Testing in your application","type":"extras"},{"doc":"ETS tableThe ETS table is always public, and by default it is of set type. Some ETS parameters can be changed:ConCache.start_link(ets_options: [ :named_table, {:name, :test_name}, :ordered_set, {:read_concurrency, true}, {:write_concurrency, true}, {:heir, heir_pid} ])Additionally, you can override ConCache, and access ETS directly::ets.insert(ConCache.ets(cache), {key, value})Of course, this completely overrides additional ConCache behavior, such as ttl, row locking and callbacks.Bag and Duplicate BagThose types are now supported by ConCache but like ETS, some functions are not supported by those types. Here are the list of functions not supported by bag and duplicate bag type tables:update/3dirty_update/3update_existing/3dirty_update_existing/3get_or_store/3dirty_get_or_store/3fetch_or_store/3dirty_fetch_or_store/3LockingTo provide isolation, custom implementation of mutex is developed. This enables that each update operation is executed in the caller process, without the need to send data to another sync process.When a modification operation is called, the ConCache first acquires the lock and then performs the operation. The acquiring is done using the pool of lock processes that reside in the ConCache supervision tree. The pool contains as many processes as there are schedulers.If the lock is not acquired in a predefined time (default = 5 seconds, alter with acquire_lock_timeout ConCache parameter) an exception will be generated.You can use explicit isolation to perform isolated reads if needed. In addition, you can use your own lock ids to implement bigger granularity:ConCache.isolated(cache, key, fn() -&gt; ConCache.get(cache, key) # isolated read end) # Operation isolated on an arbitrary id. The id doesn&#39;t have to correspond to a cache item. ConCache.isolated(cache, my_lock_id, fn() -&gt; ... end) # Same as above, but immediately returns {:error, :locked} if lock could not be acquired. ConCache.try_isolated(cache, my_lock_id, fn() -&gt; ... end)Keep in mind that these calls are isolated, but not transactional (atomic). Once something is modified, it is stored in ETS regardless of whether the remaining calls succeed or fail. The isolation operations can be arbitrarily nested, although I wouldn't recommend this approach.TTLWhen ttl is configured, the owner process works in discrete steps using :erlang.send_after to trigger the next step.When an item ttl is set, the owner process receives a message and stores it in its internal structure without doing anything else. Therefore, repeated touching of items is not very expensive.In the next discrete step, the owner process first applies the pending ttl set requests to its internal state. Then it checks which items must expire at this step, purges them, and calls :erlang.send_after to trigger the next step.This approach allows the owner process to do fairly small amount of work in each discrete step.ConsequencesDue to the locking and ttl algorithms just described, some additional processing will occur in the owner processes. The work is fairly optimized, but I didn't invest too much time in it. For example, lock processes currently use pure functional structures such as HashDict and :gb_trees. This could probably be replaced with internal ETS table to make it work faster, but I didn't try it.Due to locking and ttl inner workings, multiple copies of each key exist in memory. Therefore, I recommend avoiding complex keys.","ref":"readme.html#inner-workings","title":"ConCache - Inner workings","type":"extras"},{"doc":"ConCache has been used in production to manage several thousands of entries served to up to 4000 concurrent clients, on the load of up to 2000 reqs/sec. I don't maintain that project anymore, so I'm not aware of its current status.","ref":"readme.html#status","title":"ConCache - Status","type":"extras"},{"doc":"Copyright (c) 2013 Saša JurićReleased under the MIT License, which can be found in the repository in LICENSE.","ref":"readme.html#copyright-and-license","title":"ConCache - Copyright and License","type":"extras"}]